curl --request POST \
--url https://api.e2b.app/v2/sandboxes \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"templateID": "<string>",
"timeout": 300,
"cpuCount": 2,
"autoPause": false,
"autoPauseMemory": true,
"allow_internet_access": true,
"network": {
"allowPublicTraffic": true,
"allowOut": [
"<string>"
],
"denyOut": [
"<string>"
],
"dnsServers": [
"<string>"
],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": true,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [
32768
],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": {
"tokens": {}
},
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
'import requests
url = "https://api.e2b.app/v2/sandboxes"
payload = {
"templateID": "<string>",
"timeout": 300,
"cpuCount": 2,
"autoPause": False,
"autoPauseMemory": True,
"allow_internet_access": True,
"network": {
"allowPublicTraffic": True,
"allowOut": ["<string>"],
"denyOut": ["<string>"],
"dnsServers": ["<string>"],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": True,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [32768],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": { "tokens": {} },
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
templateID: '<string>',
timeout: 300,
cpuCount: 2,
autoPause: false,
autoPauseMemory: true,
allow_internet_access: true,
network: {
allowPublicTraffic: true,
allowOut: ['<string>'],
denyOut: ['<string>'],
dnsServers: ['<string>'],
egressProxy: {
address: '<string>',
username: '<string>',
password: '<string>',
tls: {enabled: true, serverName: '<string>', caCert: '<string>'}
},
maskRequestHost: '<string>',
httpsPorts: [32768],
rules: {}
},
metadata: {},
envVars: {},
mcp: {},
iam: {tokens: {}},
volumeMounts: [{name: '<string>', path: '<string>'}]
})
};
fetch('https://api.e2b.app/v2/sandboxes', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.e2b.app/v2/sandboxes",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'templateID' => '<string>',
'timeout' => 300,
'cpuCount' => 2,
'autoPause' => false,
'autoPauseMemory' => true,
'allow_internet_access' => true,
'network' => [
'allowPublicTraffic' => true,
'allowOut' => [
'<string>'
],
'denyOut' => [
'<string>'
],
'dnsServers' => [
'<string>'
],
'egressProxy' => [
'address' => '<string>',
'username' => '<string>',
'password' => '<string>',
'tls' => [
'enabled' => true,
'serverName' => '<string>',
'caCert' => '<string>'
]
],
'maskRequestHost' => '<string>',
'httpsPorts' => [
32768
],
'rules' => [
]
],
'metadata' => [
],
'envVars' => [
],
'mcp' => [
],
'iam' => [
'tokens' => [
]
],
'volumeMounts' => [
[
'name' => '<string>',
'path' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.e2b.app/v2/sandboxes"
payload := strings.NewReader("{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.e2b.app/v2/sandboxes")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.e2b.app/v2/sandboxes")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_bodyCreate sandbox (v2)
Create a sandbox from the template. All system communication with the sandbox is secured.
curl --request POST \
--url https://api.e2b.app/v2/sandboxes \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"templateID": "<string>",
"timeout": 300,
"cpuCount": 2,
"autoPause": false,
"autoPauseMemory": true,
"allow_internet_access": true,
"network": {
"allowPublicTraffic": true,
"allowOut": [
"<string>"
],
"denyOut": [
"<string>"
],
"dnsServers": [
"<string>"
],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": true,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [
32768
],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": {
"tokens": {}
},
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
'import requests
url = "https://api.e2b.app/v2/sandboxes"
payload = {
"templateID": "<string>",
"timeout": 300,
"cpuCount": 2,
"autoPause": False,
"autoPauseMemory": True,
"allow_internet_access": True,
"network": {
"allowPublicTraffic": True,
"allowOut": ["<string>"],
"denyOut": ["<string>"],
"dnsServers": ["<string>"],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": True,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [32768],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": { "tokens": {} },
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
templateID: '<string>',
timeout: 300,
cpuCount: 2,
autoPause: false,
autoPauseMemory: true,
allow_internet_access: true,
network: {
allowPublicTraffic: true,
allowOut: ['<string>'],
denyOut: ['<string>'],
dnsServers: ['<string>'],
egressProxy: {
address: '<string>',
username: '<string>',
password: '<string>',
tls: {enabled: true, serverName: '<string>', caCert: '<string>'}
},
maskRequestHost: '<string>',
httpsPorts: [32768],
rules: {}
},
metadata: {},
envVars: {},
mcp: {},
iam: {tokens: {}},
volumeMounts: [{name: '<string>', path: '<string>'}]
})
};
fetch('https://api.e2b.app/v2/sandboxes', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.e2b.app/v2/sandboxes",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'templateID' => '<string>',
'timeout' => 300,
'cpuCount' => 2,
'autoPause' => false,
'autoPauseMemory' => true,
'allow_internet_access' => true,
'network' => [
'allowPublicTraffic' => true,
'allowOut' => [
'<string>'
],
'denyOut' => [
'<string>'
],
'dnsServers' => [
'<string>'
],
'egressProxy' => [
'address' => '<string>',
'username' => '<string>',
'password' => '<string>',
'tls' => [
'enabled' => true,
'serverName' => '<string>',
'caCert' => '<string>'
]
],
'maskRequestHost' => '<string>',
'httpsPorts' => [
32768
],
'rules' => [
]
],
'metadata' => [
],
'envVars' => [
],
'mcp' => [
],
'iam' => [
'tokens' => [
]
],
'volumeMounts' => [
[
'name' => '<string>',
'path' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.e2b.app/v2/sandboxes"
payload := strings.NewReader("{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.e2b.app/v2/sandboxes")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.e2b.app/v2/sandboxes")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"templateID\": \"<string>\",\n \"timeout\": 300,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_bodyHeaders
Optional team-scoped key for retrying sandbox creation. Use 1 to 255 lowercase ASCII letters, digits, or hyphens (a-z, 0-9, -), such as a lowercase UUID. When idempotency is enabled, matching retries replay a completed status and body for the retention period. A creation failure explicitly classified as safe to retry (Should-Retry: true) permits a fresh attempt with the same key and parameters. Only one attempt can run at a time. Different request parameters return 409 with error_code idempotency_request_mismatch. An in-progress request returns 409 with error_code idempotency_in_progress; an unknown outcome returns 422 with error_code idempotency_outcome_unknown. These retries do not execute the request again. Retries do not extend retention. If a fresh attempt's request deadline plus response persistence budget would exceed the remaining retention, the previous error is replayed. After the key expires, it can start a new creation.
1 - 255^[a-z0-9-]+$Body
Sandbox creation request. All system communication with the sandbox is always secured; the template's envd version must support secured access.
Controls the snapshot kind taken when the sandbox auto-pauses on timeout (only relevant when autoPause is true). When false, the auto-pause drops the in-memory state and persists only the filesystem (a filesystem-only snapshot); resuming it cold-boots (reboots) the sandbox from disk. Such a snapshot cannot be auto-resumed by traffic and must be resumed explicitly, so it cannot be combined with autoResume. Defaults to true (full memory snapshot).
Response
The sandbox was created successfully
Was this page helpful?